TOOLS32       =  c:\progra~1\micros~1\vc98
cc32 = $(TOOLS32)\bin\cl -I$(TOOLS32)\include
rc32 = c:\progra~1\micros~1\common\msdev98\bin\rc
link32 = $(TOOLS32)\bin\link

#Uncomment this line to compile an optimized (with no debug symbols) version of the program.
NODEBUG=1
TARGETOS=WIN95
!include <ntwin32.mak>

TK_DIR  = ..\tk-8.0
TCL_DIR = ..\tcl-8.0
INCLUDE_TK = -I$(TK_DIR)\win -I$(TK_DIR)\generic
INCLUDE_TCL = -I$(TCL_DIR)\win -I$(TCL_DIR)\generic
INCLUDE_X11 = -I$(TK_DIR)\xlib

GENERICDIR	= $(TK_DIR)\generic
RCDIR		= $(TK_DIR)\win\rc

LIB_TK = \src\tk-8.0\win\Release\tklib.lib
LIB_TCL = \src\tcl-8.0\win\Release\tcllib.lib
LIBRARY_TK	= $(TK_DIR)\library
LIBRARY_TCL	= $(TCL_DIR)\library

LIBS = $(LIB_TCL) $(LIB_TK) $(guilibs) wsock32.lib
CFLAGS		= $(INCLUDE_X11) $(INCLUDE_TK) $(INCLUDE_TCL) -DNEED_INET_ATON -DNEED_INET_PTON -DDEBUG -DRELATE_INT -DWIN32 -D_Windows -DWIN32_LEAN_AND_MEAN

.c.obj:
	$(cc32) $(cdebug) $(cflags) $(cvars) $(CFLAGS) -o $@ -FR$*.sbr $<

# Tcl initialisation files to be compiled into a C string.
TCL_LIBS = \
	ui_audiotool.tcl \
 	relate.tcl 

INC	= net_udp.h util.h mbus.h mbus_ui.h config.h
SRC	= net_udp.c main.c mbus.c mbus_ui.c util.c lbl_confbus.c tcltk.c win32.c
OBJ	= tk.res tcllibs.obj net_udp.obj main.obj mbus.obj mbus_ui.obj util.obj lbl_confbus.obj tcltk.obj win32.obj

relate	:	$(OBJ) $(INC)
	$(link32) $(ldebug) $(guilflags) -out:$@.exe tk.res $(OBJ) $(LIBS)

clean	: del *.obj

# tcl2c comes from Ron Frederick's (Xerox) nv distribution.
tcl2c	:	tcl2c.obj
	$(link32) $(CFLAGS) tcl2c.obj $(LIBS) -out:tcl2c.exe

# Tcl library files are turned into a single object file.

tcllibs.obj: $(TCL_FILES) tcl2c.exe
	tcl2c.exe 1 $(TCL_LIBS) >tcllibs.c
	$(cc32) /c $(CFLAGS) tcllibs.c

tk.res:
	$(rc32) -fo $@ -r -i $(GENERICDIR) $(RCDIR)/tk.rc
